#include <iostream>
#include <vector>

class Employe{
private:
    static unsigned int next_id;
protected:
    std::string nom;
    const unsigned int id;

public:
    Employe(const std::string& n): nom (n), id (next_id++){}
    virtual unsigned int Niveau() const {return 0;}
    virtual void affiche()const;
   
};

class Manager: public Employe{

    unsigned int niveau;
    std::vector<Employe> equipe;
    
public:
    Manager(const std::string& n): Employe(n), niveau(0){}

    Manager(const std::string& n, std::vector<Employe> & eq):
            Employe(n),
            equipe(eq)
        {
            niveau = 0;
            for (auto x : equipe){
                if (x.Niveau() >= niveau)
                    niveau = x.Niveau()+1;
            }
        }
    unsigned int Niveau() const override {return niveau;}

    void ajouteEquipe(Employe& em){
        equipe.push_back(em);
        if (em.Niveau() >= niveau)
            niveau = em.Niveau() +1;
    }
};
